#include <SoftwareSerial.h>
SoftwareSerial mySerial(3,4);

//#include <MsTimer2.h>

String comdata = "";

int PowerState;


int Flag_Set = 0;
int NumFlag = 0;

int Buzzer = 8;
int LedRed = 12;
int LedBlue =13;

int LeftFront_1 = 7;
int LeftFront_2 = 6;
int enA = 5;  

int LeftBehind_1 = 10;
int LeftBehind_2 = 9;
int enB = 11;

int RightFront_1 = A3;
int RightFront_2 = A4;
int enC = A5;

int RightBehind_1 = A1;
int RightBehind_2 = A2;
int enD = A0;

int TotalWidth = 255;
int PWM_width = 235; //定义前进后退脉冲高电平微秒数

void setup() {
  Serial.begin(115200);
  //mySerial.begin(115200);

  pinMode(Buzzer,OUTPUT);
  pinMode(LeftFront_1,OUTPUT);
  pinMode(LeftFront_2,OUTPUT);
  pinMode(enA,OUTPUT);

  pinMode(LeftBehind_1,OUTPUT);
  pinMode(LeftBehind_2,OUTPUT);
  pinMode(enB,OUTPUT);

  pinMode(RightFront_1,OUTPUT);
  pinMode(RightFront_2,OUTPUT);
  pinMode(enC,OUTPUT); 

  pinMode(RightBehind_1,OUTPUT);
  pinMode(RightBehind_2,OUTPUT);
  pinMode(enD,OUTPUT); 

  pinMode(LedRed,OUTPUT); 
  pinMode(LedBlue,OUTPUT); 
  pinMode(Buzzer,OUTPUT); 

  //MsTimer2::set(100, SoftSerialCtrl);        // 中断设置函数，每 500ms 进入一次中断
  //MsTimer2::start(); 
  
  digitalWrite(LedRed,HIGH);
  digitalWrite(LedBlue,LOW);
  digitalWrite(Buzzer,LOW);
  
} 



void PWMCtrl(int tFirst,int tSecond, int tThrid, int tFourth){

      digitalWrite(enA,HIGH);
      digitalWrite(enB,HIGH);
      digitalWrite(enC,HIGH);
      digitalWrite(enD,HIGH);  
      for(unsigned char i=0;i<TotalWidth;i++)
      {
          if(tFirst>255)
              tFirst = 255;
          if(tSecond>255)
              tSecond = 255;
          if(tThrid>255)
              tThrid = 255;
          if(tThrid>255)
              tFourth = 255;
          delayMicroseconds(1); 
          if(i==tFirst)
              digitalWrite(enA,LOW);
          if(i==tSecond)
              digitalWrite(enB,LOW);
          if(i==tThrid)
              digitalWrite(enC,LOW);
          if(i==tFourth)
              digitalWrite(enD,LOW);
      }
  }
void GoForward(int tFirstF, int tSecondF, int tThridF, int tFourthF){   //前进     

      
      digitalWrite(LeftFront_1,LOW);
      digitalWrite(LeftFront_2,HIGH);
      
      digitalWrite(LeftBehind_1,LOW);
      digitalWrite(LeftBehind_2,HIGH);
      
      digitalWrite(RightFront_1,LOW);
      digitalWrite(RightFront_2,HIGH);

      digitalWrite(RightBehind_1,LOW);
      digitalWrite(RightBehind_2,HIGH);
      
      PWMCtrl(tFirstF,tSecondF,tThridF,tFourthF);
      }



void GoBack(int tFirstB, int tSecondB, int tThridB, int tFourthB){   //后退    

      
      digitalWrite(LeftFront_1,HIGH);
      digitalWrite(LeftFront_2,LOW);
      
      digitalWrite(LeftBehind_1,HIGH);
      digitalWrite(LeftBehind_2,LOW);
      
      digitalWrite(RightFront_1,HIGH);
      digitalWrite(RightFront_2,LOW);

      digitalWrite(RightBehind_1,HIGH);
      digitalWrite(RightBehind_2,LOW);
      
      PWMCtrl(tFirstB,tSecondB,tThridB,tFourthB);
      }

void MvLeft(int tFirstB, int tSecondB, int tThridB, int tFourthB){    

      
      digitalWrite(LeftFront_1,HIGH);
      digitalWrite(LeftFront_2,LOW);
      
      digitalWrite(LeftBehind_1,LOW);
      digitalWrite(LeftBehind_2,HIGH);
      
      digitalWrite(RightFront_1,HIGH);
      digitalWrite(RightFront_2,LOW);

      digitalWrite(RightBehind_1,LOW);
      digitalWrite(RightBehind_2,HIGH);
      
      PWMCtrl(tFirstB,tSecondB,tThridB,tFourthB);
      }


void TurnLeft(int tFirstL, int tSecondL, int tThridL, int tFourthL){
      digitalWrite(LeftFront_1,HIGH);
      digitalWrite(LeftFront_2,LOW);
      
      digitalWrite(LeftBehind_1,HIGH);
      digitalWrite(LeftBehind_2,LOW);
      
      digitalWrite(RightFront_1,LOW);
      digitalWrite(RightFront_2,HIGH);

      digitalWrite(RightBehind_1,LOW);
      digitalWrite(RightBehind_2,HIGH);
      
      PWMCtrl(tFirstL,tSecondL,tThridL,tFourthL); 
  }

 
  
  void TurnRight(int tFirstR, int tSecondR, int tThridR, int tFourthR){
      digitalWrite(LeftFront_1,LOW);
      digitalWrite(LeftFront_2,HIGH);
      
      digitalWrite(LeftBehind_1,LOW);
      digitalWrite(LeftBehind_2,HIGH);
      
      digitalWrite(RightFront_1,HIGH);
      digitalWrite(RightFront_2,LOW);

      digitalWrite(RightBehind_1,HIGH);
      digitalWrite(RightBehind_2,LOW);
      
      
      PWMCtrl(tFirstR,tSecondR,tThridR,tFourthR);  
  }

  
  
  void StopRun(){
      digitalWrite(LeftFront_1,LOW);
      digitalWrite(LeftFront_2,LOW);
      
      digitalWrite(LeftBehind_1,LOW);
      digitalWrite(LeftBehind_2,LOW);
      
      digitalWrite(RightFront_1,LOW);
      digitalWrite(RightFront_2,LOW);

      digitalWrite(RightBehind_1,LOW);
      digitalWrite(RightBehind_2,LOW);
      
  }

  void LeftCorrect(int tFirstLC, int tSecondLC, int tThridLC,int tFourthLC){
      digitalWrite(LeftFront_1,HIGH);
      digitalWrite(LeftFront_2,LOW);
      
      digitalWrite(LeftBehind_1,HIGH);
      digitalWrite(LeftBehind_2,LOW);
      
      digitalWrite(RightFront_1,LOW);
      digitalWrite(RightFront_2,HIGH);

      digitalWrite(RightBehind_1,LOW);
      digitalWrite(RightBehind_2,HIGH);
      
      PWMCtrl(tFirstLC,tSecondLC,tThridLC,tFourthLC); 
  }

  void RightCorrect(int tFirstRC, int tSecondRC, int tThridRC,int tFourthRC){
      digitalWrite(LeftFront_1,LOW);
      digitalWrite(LeftFront_2,HIGH);
      
      digitalWrite(LeftBehind_1,LOW);
      digitalWrite(LeftBehind_2,HIGH);
      
      digitalWrite(RightFront_1,HIGH);
      digitalWrite(RightFront_2,LOW);

      digitalWrite(RightBehind_1,HIGH);
      digitalWrite(RightBehind_2,LOW);
      
      PWMCtrl(tFirstRC,tSecondRC,tThridRC,tFourthRC);  
  }

void SerialCtrl()
{
    while (Serial.available() > 0)  
    {
        comdata += char(Serial.read());
        delay(2);
    }
    if (comdata.length() > 0)
    {
      /*if(comdata.length()==11)
        {
          if(comdata[0] == 0x7B && comdata[10] == 0x7D)
          { 

            speed_x = (comdata[3] & 0x0f)+(comdata[4])*0.1;
            speed_y = (comdata[5] & 0x0f)+(comdata[6])*0.1;
            speed_z = (comdata[7] & 0x0f)+(comdata[8])*0.1;
            if((comdata[3] & 0xf0) >> 4 == 0x0f){
                speed_x = -((comdata[3] & 0x0f)+(comdata[4])*0.1);
              }
            if((comdata[5] & 0xf0) >> 4 == 0x0f){
                speed_y = -((comdata[5] & 0x0f)+(comdata[6])*0.1);
              }
            if((comdata[7] & 0xf0) >> 4 == 0x0f){
                speed_z = -((comdata[7] & 0x0f)+(comdata[8])*0.1);
              }
            
            //Serial.print("speed_x:");
            //Serial.println(speed_x);
            //Serial.print("speed_y:");
            //Serial.println(speed_y);
            //Serial.print("speed_z:");
            //Serial.println(speed_z);
          }
        }*/
        if (comdata == "DOA"){
            Flag_Set = 1;  
            }
          else if (comdata == "DOB"){
            Flag_Set = 2;
            }
          else if (comdata == "DOC"){
            Flag_Set = 3;
            }
          else if (comdata == "DOD"){
            Flag_Set = 4;
            }
          else if (comdata == "DOE"){
            Flag_Set = 5;
            }
          else if (comdata == "DOH"){
            Flag_Set = 6;
            }
          else if (comdata == "DOI"){
            Flag_Set = 7;
            } 
        NoResponse();     
        comdata = "";
    }
}

void SoftSerialCtrl()
{
    while (mySerial.available() > 0)  
    {
        comdata += char(mySerial.read());
        delay(2);
    }
    if (comdata.length() > 0)
    {
        if (comdata == "DOA"){
            Flag_Set = 1;  
            }
          else if (comdata == "DOB"){
            Flag_Set = 2;
            }
          else if (comdata == "DOC"){
            Flag_Set = 3;
            }
          else if (comdata == "DOD"){
            Flag_Set = 4;
            }
          else if (comdata == "DOE"){
            Flag_Set = 5;
            }
          else if (comdata == "DOH"){
            Flag_Set = 6;
            }
          else if (comdata == "DOI"){
            Flag_Set = 7;
            }     
        comdata = "";
    }
}

void FlagCtrl(){
      if(Flag_Set == 1){
    GoForward(235,235,235,235);
    }
    else if(Flag_Set == 2){
      GoBack(235,235,235,235);
      }
    else if(Flag_Set == 3){
      TurnLeft(235,235,235,235);
      }
    else if(Flag_Set == 4){
      TurnRight(235,235,235,235);
      }
    else if(Flag_Set == 5){
      StopRun();
      }
    else if(Flag_Set == 6){
      LeftCorrect(225,225,225,225);
      }
    else if(Flag_Set == 7){
      RightCorrect(225,225,225,225);
      }
  }

/*void SerialRxInit(){
    if(RxBuf[0] == 0x7B && RxBuf[Rxcount-1 == 0x7D])
    {
        if(Check_Sum(RxBuf,9,RxBuf[Rxcount-2]) == TURE)
        {
            speed_x = (RxBuf[3] << 8)+RxBuf[4];
            speed_y = (RxBuf[5] << 8)+RxBuf[6];
            speed_z = (RxBuf[7] << 8)+RxBuf[8];
          }
      }
  }*/


void NoResponse(){
    volatile long TimFlag = 0;
    if(comdata == "DOE"){
        NumFlag++;
        if(NumFlag == 20){
              for(; TimFlag<=500; TimFlag++){
                  TurnRight(220,220,220,220); 
                }
              TimFlag = 0;
              NumFlag = 0;
            }
    }
    else{ 
        NumFlag = 0;
      }
  }

void BuzzerBeep(){
    if (analogRead(A6) <= 330 && analogRead(A6) >= 250) {
            delay(200);
            if(analogRead(A6) <= 339){
            digitalWrite(12,LOW);
            digitalWrite(13,HIGH);
            StopRun();
            while(1){
            digitalWrite(Buzzer,HIGH);
            delay(300);
            digitalWrite(Buzzer,LOW);
            delay(300);
           }
        }
     }
    if(PowerState < 250){
      digitalWrite(LedRed,LOW);
      digitalWrite(LedBlue,HIGH);
    }
      
  }

void LowPower(){
    static u8 LEDFlag = 0;
    static unsigned long systick_ms_bak = 0;
    PowerState = analogRead(A6);
    if(PowerState <= 385 && PowerState > 330){
          digitalWrite(LedBlue,HIGH);
        if(millis() - systick_ms_bak > 500) {
      systick_ms_bak = millis();
      if(LEDFlag) {
        digitalWrite(12,LOW);
      } else {
        digitalWrite(12,HIGH);  
      }
      LEDFlag = !LEDFlag;
    }
  }
  if(PowerState > 385){
      digitalWrite(LedBlue,LOW);
      digitalWrite(LedRed,HIGH );
    }
}

/*void CarStatus(){
    unsigned short OldFlag = 0;
    float va, vb, vc, vd;
    MotorTarget_A = (speed_x+speed_y-speed_z*(Wheel_spacing+Wheel_axlespacing));
    MotorTarget_B = (speed_x-speed_y-speed_z*(Wheel_spacing+Wheel_axlespacing));
    MotorTarget_C = (speed_x+speed_y+speed_z*(Wheel_spacing+Wheel_axlespacing));
    MotorTarget_D = (speed_x-speed_y+speed_z*(Wheel_spacing+Wheel_axlespacing))
    if(speed_z == 0){
        va = MotorTarget_A*250;
        vb = MotorTarget_B*250;
        vc = MotorTarget_C*250;
        vd = MotorTarget_D*250;
        if(speed_x > 0){
            GoForward(va,vb,vc,vd);
          }
         if(speed_x < 0){
            GoBack(va,vb,vc,vd);
          }
      }
      if(speed_z > 0){
            TurnLeft(va,vb,vc,vd );
          }
      if(speed_z < 0){
            TurnRight(va,vb,vc,vd);
          }
      if(speed_x == 0 && speed_y == 0 && speed_z == 0){
        StopRun();
      }*/

    
void loop(){
    SerialCtrl();
    //SoftSerialCtrl();
    FlagCtrl();
    LowPower();
    BuzzerBeep();
 }
